#!/usr/bin/env python
from __future__ import generators
# import findrox; findrox.version(1,9,12)
# it uses a patched version of ROX-Lib2 in rox/
import rox
from rox import applet, g, InfoWin, tasks, ButtonMixed, choices, options
from rox.options import Option
import sys

from xml.dom import minidom
import xml.sax
import urllib

import gc
import os
import re
import gobject

import tool

class source_(gobject.GObject):
	def __init__(self, Options):
		gobject.GObject.__init__(self)
		self.__Options = Options
		self.active = None
		self.ticker = None
		self.icon = None
		self.iconcache = None
		self.shownews = None
		self.news_age_by_date = None
		self.provides_date_info = None
	def copy(self, source_):
		if self.active <> source_.active: self.active = source_.active; self.emit("change_active")
		if self.icon <> source_.icon: self.icon = source_.icon; #self.emit("change_icon")
		if self.iconcache <> source_.iconcache: self.iconcache = source_.iconcache; #self.emit("change_iconcache")
		if self.shownews <> source_.shownews: self.shownews = source_.shownews; self.emit("change_shownews")
		if self.news_age_by_date <> source_.news_age_by_date: self.news_age_by_date = source_.news_age_by_date; self.emit("change_news_age_by_date")
		if self.provides_date_info <> source_.provides_date_info: self.provides_date_info = source_.provides_date_info; self.emit("change_provides_date_info")
		"""
	def set(self, active, ticker, icon, iconcache, shownews,\
			news_by_age_date, provides_date_info):
		self.active = active
		self.ticker = ticker
		self.icon = icon
		self.iconcache = iconcache
		self.shownews = shownews
		self.news_age_by_date = news_age_by_date
		self.provides_date_info = provides_date_info
		"""
	def get_active(self): return self.active
	def get_ticker(self):
		if self.ticker.find("://") == -1: return "http://" + self.ticker
		else: return self.ticker
	def get_icon(self):
		icon = self.icon
		if icon == "":
			pos = self.ticker[8:].find("/")
			if pos <> -1: pos = pos + 8
			if pos <> -1: icon =  self.ticker[:pos] + "/favicon.ico"
			else:	icon =  self.ticker + "/favicon.ico"
		else:
			if icon.find("://") == -1: icon = "http://" + icon
		return icon
	def get_iconcache(self):
		iconcache = self.iconcache
		if iconcache == "":
			iconcache = tool.tmp_name(self.__Options.icon_cache_dir.value, self.get_icon())
		return iconcache
	def get_shownews(self): return self.shownews
	def get_news_age_by_date(self): return self.news_age_by_date
	def get_provides_date_info(self): return self.provides_date_info
	def _to_xml(self, parent):
		def createNode(doc, name, data):
			node = doc.createElement(name)
			node.appendChild(doc.createTextNode(data))
			return node
		doc = parent.ownerDocument
		parent.appendChild(createNode(doc, 'active', str(self.active)))
		parent.appendChild(createNode(doc, 'ticker', self.ticker))
		parent.appendChild(createNode(doc, 'icon', self.icon))
		parent.appendChild(createNode(doc, 'iconcache', self.iconcache))
		parent.appendChild(createNode(doc, 'shownews', str(self.shownews)))
		parent.appendChild(createNode(doc, 'news_age_by_date',\
			str(self.news_age_by_date)))
		parent.appendChild(createNode(doc, 'provides_date_info',\
			str(self.provides_date_info)))
		return doc
	def _from_xml(self, xml_source):
		self.active = tool.getintdata(xml_source, "active")
		self.ticker = tool.getdata(xml_source, "ticker")
		self.icon  = tool.getdata(xml_source, "icon")
		self.iconcache = tool.getdata(xml_source, "iconcache")
		self.shownews = tool.getintdata(xml_source, "shownews")
		self.news_age_by_date = tool.getintdata(xml_source, "news_age_by_date")
		self.provides_date_info = tool.getintdata(xml_source, "provides_date_info")

gobject.signal_new("source_killed", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE,  (gobject.TYPE_PYOBJECT,))

gobject.signal_new("change_active", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("change_ticker", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("change_icon", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("change_iconcache", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("change_shownews", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("change_news_age_by_date", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("change_provides_date_info", source_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())

class sources_(gobject.GObject):
	def __init__(self, Options):
		gobject.GObject.__init__(self)
		self.__Options = Options
		self.sources = []
		self.reinit_wait_cont = tool.WaitContainer(0.5, self.reinit_from_xml_)
		#self.__xml_string = None
		#self.__waiting = None
		#self.valid = True
	def stat_sources(self, sources):
		source_count = len(sources)
		act_count = 0
		for i in sources:
			if i.get_active() == 1: act_count += 1
		return str(source_count) + "[all]/" + str(act_count) + "[active]"
	def stat(self): return self.stat_sources(self.sources)
	def switch_feed_active(self, feed):
		print feed.ticker
		print feed.get_active()
		source = self.get_by_ticker(feed.ticker)
		if source.active == 1: source.active = 0
		else: source.active = 1
		print "switch feed active: " + feed.ticker + " set to " + str(feed.get_active())
		self.get_by_ticker(feed.ticker).emit("change_active")
	def get_by_ticker(self, ticker):
		if ticker.find("://") == -1: ticker = "http://" + ticker
		for source in self.sources:
			#print "get_by_ticker " + source.ticker + " vs. " + ticker
			if source.get_ticker() == ticker: return source
		return None
	def get_active_by_ticker(self, ticker):
		if self.get_by_ticker(ticker): return self.get_by_ticker(ticker).active
		else: return None
	def get_ticker_by_ticker(self, ticker):
		if self.get_by_ticker(ticker): return self.get_by_ticker(ticker).ticker
		return None
	def get_icon_by_ticker(self, ticker):
		if self.get_by_ticker(ticker): return self.get_by_ticker(ticker).icon
		return None
	def get_iconcache_by_ticker(self, ticker):
		if self.get_by_ticker(ticker): return self.get_by_ticker(ticker).iconcache
		return None
	def get_shownews_by_ticker(self, ticker):
		if self.get_by_ticker(ticker): return self.get_by_ticker(ticker).shownews
		return None
	def get_news_age_by_date_by_ticker(self, ticker):
		if self.get_by_ticker(ticker): return self.get_by_ticker(ticker).news_age_by_date
		return None
	def get_provides_date_info_by_ticker(self, ticker):
		if self.get_by_ticker(ticker): return self.get_by_ticker(ticker).provides_date_info
		return None
	def export_xml(self):
		from xml.dom.minidom import Document
		doc = Document()
		doc_root = doc.createElement('Options')
		doc.appendChild(doc_root)
		for i in self.sources:
			root = doc.createElement('source')
			doc_root.appendChild(root)
			i._to_xml(root)
		return doc.toxml()
	def init_from_xml(self, xml_string):
		#print "sources (" + self.stat() + ")"
		for source in self.sources:
			source.emit("source_killed", source.get_ticker())
		self.sources = []
		#print "sources (" + self.stat() + ")"
		try:
			doc=minidom.parseString(xml_string)
		except xml.sax.SAXParseException:
			print "something stupid happend: your internal config is corrupt"
			return
		xml_sources = doc.getElementsByTagName("source")
		for xml_source in xml_sources:
			#print "neue source"
			new_source = source_(self.__Options)
			new_source._from_xml(xml_source)
			self.sources.append(new_source)
	def reinit_from_xml(self, xml_string):
		self.reinit_wait_cont.set_value(xml_string)
	def reinit_from_xml_(self, xml_string):
		tmp_sources = []
		try:
			doc=minidom.parseString(xml_string)
		except xml.sax.SAXParseException:
			print "something stupid happend: your internal config is corrupt"
			return
		xml_sources = doc.getElementsByTagName("source")
		for xml_source in xml_sources:
			new_source = source_(self.__Options)
			new_source._from_xml(xml_source)
			tmp_sources.append(new_source)
		#print "old sources (" + self.stat() + ")"
		#print "new sources (" + self.stat_sources(tmp_sources) + ")"
		### now tmp_sources holds the new configuration, its time to copy this into old one
		i = 0
		#yield None
		while (i < len(self.sources)):
			#print i
			for tmp_source in tmp_sources:
				#print "check " + self.sources[i].get_ticker() + " against " + tmp_source.get_ticker()
				if tmp_source.get_ticker() == self.sources[i].get_ticker():
					self.sources[i].copy(tmp_source);
					#print "**** " + tmp_source.get_ticker() + " found, going on"
					break
			if tmp_source.get_ticker() <> self.sources[i].get_ticker():
				print "kill feed cause not found in Sources: " + self.sources[i].get_ticker()
				self.sources[i].emit("source_killed", self.sources[i].get_ticker())
				self.sources.pop(i)
			else: i += 1
		### and now its time to add new sources
		#yield None
		for source in tmp_sources:
			if self.get_by_ticker(source.get_ticker()): continue
			print source.get_ticker() + " not found, added"
			self.sources.append(source)
		#print "act sources (" + self.stat() + ")"

class Options_(gobject.GObject):
	def __init__(self, V, Version, user_conf, verbose):
		gobject.GObject.__init__(self)
		## store some init-variables for global access
		self.Version = Version
		self.v = verbose
		if self.v: print "Verbose mode activated"
		pos = V.find(".") + 1
		pos += V[pos:].find(".")
		self.program = "RETicker_" + V[:pos]	+ user_conf
		rox.setup_app_options(self.program)
		
		#global ticker_menu
		#import ticker_menu
		#ticker_menu.set_save(program)
	
		# How to decide if 'news' are old
		self.news_age = Option('news_age', '60') # in Min
		self.news_showcount = Option('news_showcount', '0')
		
		# Sources - there are two versions, see section further down, variable sources
		self.sources = sources_(self)
		self.sources.init_from_xml("<Options><source><active>1</active>" \
			+ "<ticker>http://slashdot.org/slashdot.rdf</ticker>" \
			+ "<icon>http://slashdot.org/favicon.ico</icon>" \
			+ "<iconcache></iconcache><shownews>5</shownews></source></Options>")
		self.__sources = Option('sources', self.sources.export_xml())
	
		# Layout-Options for Ticker
		self.text_color = Option('text_color', '#880000')
		self.back_color = Option('back_color', '#DEDBD6')
		self.transparent = Option('transparent', '0')
		self.back_datei = Option('back_datei', '')
		self.hor_size=Option('hor_size', '-1')
		self.ver_size=Option('ver_size', '20')
		
		
		# Layout-Optionen (Overview-Window)
		self.show_age = Option('show_age', '1')
		self.show_stat = Option('show_stat', '1')
		self.ov_bg = Option('ov_bg', '#FFFFFF')
		self.ov_bg_inactive = Option('ov_bg_inactive', '#888888')
		self.ov_bg_stat = Option('ov_bg_stat', '#D70707')
		self.ov_color_new_msg = Option('color_new_msg', '#880000')
		self.ov_color_old_msg = Option('color_old_msg', '#000000')
		self.ov_color_not_shown_msg = Option('color_not_shown_msg', '#666666')
		self.ov_hor_size=Option('ov_hor_size', '400')
		self.ov_ver_size=Option('ov_ver_size', '600')

		# ActiveTooltip-Design
		self.tt_a=Option('tt_a', '1')
		self.tt_a_inactive_fd=Option('tt_a_inactive_fd', '0')
		self.tt_a_fd_wo_news=Option('tt_a_fd_wo_news', '1')
		self.tt_a_as_menu=Option('tt_a_as_menu', '0')
		self.tt_a_bg = Option('tt_a_bg', '#eee2b4')
		self.tt_a_bg_inactive = Option('tt_a_bg_inactive', '#cec294')
		self.tt_a_bg_stat = Option('tt_a_bg_stat', '#eee2b4')
		self.tt_a_color_new_msg = Option('tt_a_color_new_msg', '#880000')
		self.tt_a_color_old_msg = Option('tt_a_color_old_msg', '#000000')
		self.tt_a_color_not_shown_msg = Option('tt_a_color_not_shown_msg', '#666666')
		self.tt_a_hor_size=Option('tt_a_hor_size', '200')
		self.tt_a_ver_size=Option('tt_a_ver_size', '200')
		self.tt_a_hor_scrollbar=Option('tt_a_hor_scrollbar', '0')
		self.tt_a_ver_scrollbar=Option('tt_a_ver_scrollbar', '1')

		# Tooltip-Design Label
		self.tt_l=Option('tt_l', '1') # zeigt Label-ToolTip mit Description an
		self.tt_l_frame=Option('tt_l_frame', '1')
		self.tt_l_title=Option('tt_l_title', '1')
		self.tt_l_link=Option('tt_l_link', '1')
		self.tt_l_ver=Option('tt_l_ver', '1')
		
		# Tooltip-Design Image
		self.tt_i=Option('tt_i', '0') # zeigt Image-ToolTip mit Description an
		self.tt_i_frame=Option('tt_i_frame', '1')
		self.tt_i_title=Option('tt_i_title', '1')
		self.tt_i_desc=Option('tt_i_desc', '1')
		self.tt_i_src=Option('tt_i_src', '1')
		self.tt_i_link=Option('tt_i_link', '1')
		self.tt_i_ver=Option('tt_i_ver', '1')

		# Fetch-Optionen
		self.update_time = Option('update_time', '15') # in sec.
		self.refresh_time= Option('refresh_time', '30') # in Min
		self.check_verbose=Option('check_verbose', '1')
		self.check_image=Option('check_image', '0')
	
		# diverse Pfade und Browser
		self.browser= Option('browser', 'opera')
		self.br_options= Option('br_options', '-newpage')
		try:
			path = os.environ['CHOICESPATH']
			paths = path.split(':')
		except KeyError:
			paths = [ os.environ['HOME'] + '/Choices',
				  '/usr/local/share/Choices',
				  '/usr/share/Choices' ]
		cache = paths[0] + '/' + self.program
		if not(os.path.exists(cache)): os.mkdir(cache)
		xml_cache_ = cache + "/xml_cache"
		if not(os.path.exists(xml_cache_)): os.mkdir(xml_cache_)
		xml_cache_ += "/News.xml"
		self.xml_cache=Option('xml_cache', xml_cache_)
		icon_cache = cache + "/icon_cache"
		if not(os.path.exists(icon_cache)): os.mkdir(icon_cache)
		self.icon_cache_dir=Option('icon_cache_dir', icon_cache)
	
		rox.app_options.notify()
		rox.app_options.add_notify(self.options_changed)
		
		# store sources Information after getting Option Value
		print "init sources (" + self.sources.stat() + ")"
		self.sources.init_from_xml(self.__sources.value)
		print "read saved sources (" + self.sources.stat() + ")"

		self.OptionsBox = None
	def sources_date_info_update(self, dummy, feed):
		self.sources.date_info_update(feed)
		self.__sources.value = self.sources.export_xml()
	def sources_switch_feed_active(self, dummy, feed):
		#print "switch feed active"
		self.sources.switch_feed_active(feed)
		self.__sources.value = self.sources.export_xml()
	def mainwin_size_changed(self, w, h):
		self.hor_size.value = str(w); self.hor_size.int_value = w
		self.ver_size.value = str(h); self.ver_size.int_value = h
	def act_tick_size_changed(self, dummy, w, h):
		self.tt_a_hor_size.value = str(w); self.tt_a_hor_size.int_value = w
		self.tt_a_ver_size.value = str(h); self.tt_a_ver_size.int_value = h
	def overview_size_changed(self, dummy, w, h):
		self.ov_hor_size.value = str(w); self.ov_hor_size.int_value = w
		self.ov_ver_size.value = str(h); self.ov_ver_size.int_value = h
	### this is called if any Option has changed **** HAS to BE adapted
	### chaneg this
	def options_changed(self):
		if self.__sources.has_changed:
			#print "sources have changed"
			### wait some seconds to be sure that 
			self.sources.reinit_from_xml(self.__sources.value)
		if self.update_time.has_changed: self.emit("refresh_update_time")
		if self.refresh_time.has_changed: self.emit("refresh_refresh_time")
		if self.hor_size.has_changed or self.ver_size.has_changed: self.emit("refresh_win_size")
		if self.ov_hor_size.has_changed or self.ov_ver_size.has_changed: self.emit("refresh_ov_size")
		if self.tt_a_hor_size.has_changed or self.tt_a_ver_size.has_changed: self.emit("refresh_tt_a_size")
		if self.text_color.has_changed or self.back_color.has_changed: self.emit("refresh_label_color")
		if self.transparent.has_changed or self.back_datei.has_changed: self.emit("refresh_transparency")
		if self.back_color.has_changed and self.transparent.int_value <> 1: self.emit("refresh_background")
		if self.tt_a_bg.has_changed or self.tt_a_bg_inactive.has_changed \
			or self.tt_a_bg_stat.has_changed or self.tt_a_color_new_msg.has_changed \
			or self.tt_a_color_old_msg.has_changed or self.tt_a_color_not_shown_msg.has_changed:
			self.emit("refresh_ov_colors")
		if self.ov_bg.has_changed or self.ov_bg_inactive.has_changed \
			or self.ov_bg_stat.has_changed or self.ov_color_new_msg.has_changed \
			or self.ov_color_old_msg.has_changed or self.ov_color_not_shown_msg.has_changed:
			self.emit("refresh_ov_colors")
		if self.tt_a_hor_scrollbar.has_changed or self.tt_a_ver_scrollbar.has_changed:
			self.emit("refresh_scrollbars")
		if self.news_age.has_changed or self.news_showcount.has_changed:
			self.emit("refresh_aging_opts")
	def show_options(self, dummy): tasks.Task(self.edit_options())
	def edit_options(self):
		yield None
		if self.OptionsBox: self.OptionsBox.present(); return
		options_file = os.path.join(rox.app_dir, 'Options.xml')
		self.OptionsBox = OptionsBox(self, rox.app_options, options_file)
		def closed(widget): self.OptionsBox = None
		self.OptionsBox.connect('destroy', closed)
		self.OptionsBox.open()

gobject.signal_new("refresh_update_time", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_refresh_time", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_win_size", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_tt_a_size", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_ov_size", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_label_color", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_transparency", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_background", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_ov_colors", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_scrollbars", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_aging_opts", Options_, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())

import rox.OptionsBox
from rox.OptionsBox import data
class OptionsBox(rox.OptionsBox.OptionsBox):
	def __init__(self, Options, options_group, options_xml, translation = None):
		self.__Options = Options
		rox.OptionsBox.OptionsBox.__init__(self, options_group, options_xml, translation = None)
		#self.connect("destroy", self.ende)
	#def ende(self, dummy):
		#print "destroy OptionsBox mod"
	def build_image(self, node, image):
		"""<image>Text</image>"""
		image = g.Image()
		Filename = rox.app_dir + "/" + data(node)
    		if os.path.exists(Filename):
    			image.set_from_file(Filename)
		else:
			image.set_from_stock(g.STOCK_MISSING_IMAGE,g.ICON_SIZE_SMALL_TOOLBAR)
		return [image]	

	def build_toggle_atip(self, node, label, option):
		"<toggle_atip name='...' label='...'>Tooltip</toggle_atip>"
		toggle = g.CheckButton(label)
		self.may_add_tip(toggle, node)
		def get():
			self.activetip.refresh(option, toggle.get_active())
			return str(toggle.get_active())
		def set():
			toggle.set_active(option.int_value)
			self.activetip.refresh(option, toggle.get_active())
		self.handlers[option] = (get, set)
		toggle.connect('toggled', lambda w: self.check_widget(option))
		return [toggle]

	def build_toggle_itip(self, node, label, option):
		"<toggle_itip name='...' label='...'>Tooltip</toggle_itip>"
		toggle = g.CheckButton(label)
		self.may_add_tip(toggle, node)
		def get():
			self.imagetip.refresh(option, toggle.get_active())
			return str(toggle.get_active())
		def set():
			toggle.set_active(option.int_value)
			self.imagetip.refresh(option, toggle.get_active())
		self.handlers[option] = (get, set)
		toggle.connect('toggled', lambda w: self.check_widget(option))
		return [toggle]

	def build_toggle_ltip(self, node, label, option):
		"<toggle_ltip name='...' label='...'>Tooltip</toggle_ltip>"
		toggle = g.CheckButton(label)
		self.may_add_tip(toggle, node)
		def get():
			self.labeltip.refresh(option, toggle.get_active())
			return str(toggle.get_active())
		def set():
			toggle.set_active(option.int_value)
			self.labeltip.refresh(option, toggle.get_active())
		self.handlers[option] = (get, set)
		toggle.connect('toggled', lambda w: self.check_widget(option))
		return [toggle]

	def build_labeltip(self, node, image):
		"""<labeltip>Text</labeltip>"""
		self.labeltip = LabelTip()
		return [self.labeltip]	

	def build_imagetip(self, node, image):
		"""<imagetip>Text</imagetip>"""
		self.imagetip = ImageTip()
		return [self.imagetip]	

	def build_activetip(self, node, image):
		"""<activetip>Text</activetip>"""
		self.activetip = ActiveTip()
		return [self.activetip]	

	def build_tickerconf(self, node, label, option):
		"""<tickerconf>alle tags als xml</tickerconf>"""
		PrefTab = TickPrefs_Container(self.__Options)
		#PrefTab = sources.Dialog
		self.may_add_tip(PrefTab, node)
		PrefTab.connect('changed_Conti', lambda t,w: self.check_widget(option))
		def get():
			return PrefTab.get_value()
		def set():
			PrefTab.load_config(option.value)
		self.handlers[option] = (get, set)
		return [PrefTab]
	def build_help(self, node, label):
		"""<help>gib ein Infofenster aus</help>"""
		HelpTab = Help_Container()
		return [HelpTab]
	def build_fileentry(self, node, label, option):
		"<fileentry name='...' label='...'>Tooltip</fileentry>"
		def open_file(widget, event):
			def set_file(widget):
				sel.hide()
				entry.set_text(sel.get_filename())
			def exit(widget):
				sel.hide()
			if event.button == 1:
				sel = g.FileSelection()
				sel.set_filename(entry.get_text())
				sel.connect("destroy", exit)
				sel.ok_button.connect("clicked", set_file)
				sel.cancel_button.connect("clicked", exit)
				sel.show()
		box = g.HBox(False, 4)
		entry = g.Entry()
		button1 = tool.EventImage(g.STOCK_OPEN, open_file, "choose file")
		
		if label:
			label_wid = g.Label(label)
			label_wid.set_alignment(1.0, 0.5)
			box.pack_start(label_wid, False, True, 0)
		box.pack_start(entry, True, True, 0)
		box.pack_start(button1, True, True, 0)
		
		self.may_add_tip(entry, node)

		entry.connect('changed', lambda e: self.check_widget(option))

		def get():
			return entry.get_chars(0, -1)
		def set():
			entry.set_text(option.value)
		self.handlers[option] = (get, set)

		return [box]

class LabelTip(g.VBox):
	def __init__(self):
		g.VBox.__init__(self)
		self.show()
		self.images = []
		self.images.append(Tip_Image(self, "label_tip_1.png", "always"))
		self.images.append(Tip_Image(self, "label_tip_2.png", "tt_l_frame"))
		self.images.append(Tip_Image(self, "label_tip_3.png", "tt_l_title"))
		self.images.append(Tip_Image(self, "label_tip_4.png", "tt_l_frame"))
		self.images.append(Tip_Image(self, "label_tip_5.png", "tt_l_desc"))
		self.images.append(Tip_Image(self, "label_tip_6.png", "tt_l_frame"))
		self.images.append(Tip_Image(self, "label_tip_7.png", "tt_l_link"))
		self.images.append(Tip_Image(self, "label_tip_8.png", "tt_l_ver"))
		self.images.append(Tip_Image(self, "label_tip_9.png", "always"))
	def refresh(self, option, state):
		for img in self.images:
			if option.name == "tt_l": img.saturate(state)
			else: img.check(option, state)

class ImageTip(g.VBox):
	def __init__(self):
		g.VBox.__init__(self)
		self.show()
		self.images = []
		self.images.append(Tip_Image(self, "image_tip_1.png", "always"))
		self.images.append(Tip_Image(self, "image_tip_2.png", "tt_i_frame"))
		self.images.append(Tip_Image(self, "image_tip_3.png", "tt_i_title"))
		self.images.append(Tip_Image(self, "image_tip_4.png", "tt_i_frame"))
		self.images.append(Tip_Image(self, "image_tip_5.png", "tt_i_desc"))
		self.images.append(Tip_Image(self, "image_tip_6.png", "tt_i_frame"))
		self.images.append(Tip_Image(self, "image_tip_7.png", "tt_i_src"))
		self.images.append(Tip_Image(self, "image_tip_8.png", "tt_i_link"))
		self.images.append(Tip_Image(self, "image_tip_9.png", "tt_i_ver"))
		self.images.append(Tip_Image(self, "image_tip_10.png", "always"))
	def refresh(self, option, state):
		for img in self.images:
			if option.name == "tt_i": img.saturate(state)
			else: img.check(option, state)

class ActiveTip(g.VBox):
	def __init__(self):
		g.VBox.__init__(self)
		self.show()
		self.image = Tip_Image(self, "active_tooltip.png", "always")
	def refresh(self, option, state):
		if option.name == "tt_a": self.image.saturate(state)
		else: self.image.check(option, state)

class Tip_Image(g.Image):
	def __init__(self, vbox, file, name):
		g.Image.__init__(self)
    		self.pxbuf = g.gdk.pixbuf_new_from_file(rox.app_dir + "/images/" + file)
		self.sat_pxbuf = g.gdk.pixbuf_new_from_file(rox.app_dir + "/images/" + file)
		self.sat_pxbuf.saturate_and_pixelate(self.sat_pxbuf, 0.01, True)
		self.set_from_pixbuf(self.pxbuf)
		self.option = name		
		self.show()
		vbox.add(self)
	def check(self, option, state):
		if option.name == self.option:
			if state == 1: self.show()
			else: self.hide()
	def saturate(self, value):
		if value == 1: self.set_from_pixbuf(self.pxbuf)
		else: self.set_from_pixbuf(self.sat_pxbuf)

class Icon_Image(tool.EventImage):
	def __init__(self):
		tool.EventImage.__init__(self, None, None, "click mal hier")
    		self.EventBuf_inactive = tool.EventBuffers()
		self.EventBuf.set_saturation = 1
		self.EventBuf_inactive.set_saturation = 1
		self.active = 0
		self.set_from_stock_(g.STOCK_MISSING_IMAGE)
	def set_active(self, active):
		self.active = active
		self.set_from_iconset()
	def set_from_iconset(self):
		if self.active == 1:
			self.image.set_from_icon_set(self.EventBuf.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
		else:
			self.image.set_from_icon_set(self.EventBuf_inactive.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
	def update_EBuf_inactive(self):
		if self.EventBuf_inactive.pixbuf: del self.EventBuf_inactive.pixbuf; self.EventBuf_inactive.pixbuf = None; gc.collect()
		self.EventBuf_inactive.pixbuf = self.EventBuf.pixbuf.copy()
		self.EventBuf_inactive.pixbuf.saturate_and_pixelate(self.EventBuf_inactive.pixbuf, 0.01, g.TRUE)
		self.EventBuf_inactive.set_image()
	def set_from_stock_(self, Stock):
		self.set_from_stock(Stock)
		self.update_EBuf_inactive()
		self.set_from_iconset()
	def get_from_file_(self,Filename, ticker = None):
		self.EventBuf.get_from_file(self, Filename)
		self.update_EBuf_inactive()
		self.set_from_iconset()
		self.set_tip(ticker)
	def get_from_uri_(self,uri,file, ticker = None):
		self.set_from_stock_(g.STOCK_REFRESH)
		try:
			urllib.urlretrieve(uri,file)
			self.get_from_file_(file)
			self.set_tip(ticker)
		except (IOError, EOFError):
			self.set_from_stock_(g.STOCK_CANCEL)
			self.set_tip(ticker)

class ConfigPage(g.VBox):
        def __init__(self, Options):
		g.VBox.__init__(self,g.FALSE,3)
		self.set_border_width(3)
		self.__Options = Options

		self.icon_image_tab = Icon_Image()

		######## ticker adress
		hbox_tick_frame = g.HBox()
		self.button2 = tool.EventImage(g.STOCK_NO, self.switch_active, "click to activate")
		self.button2.set_small()
		self.tick_frame_label = g.Label(" News Source (click button to activate)")
		hbox_tick_frame.pack_start(self.button2, g.FALSE, g.FALSE, 0)
		hbox_tick_frame.pack_start(self.tick_frame_label, g.FALSE, g.FALSE, 0)
		
		vbox_tick = g.VBox()
		vbox_tick.set_border_width(3)
		
		hbox_tick = g.HBox()
		label2 = g.Label("source http-adress")
		hbox_tick.pack_start(label2, g.FALSE, g.FALSE, 0)
		self.e_ticker = g.Entry()
		#self.e_ticker.set_size_request(248,22)
		vbox_tick.pack_start(hbox_tick, g.FALSE, g.FALSE, 0)
		vbox_tick.pack_start(self.e_ticker, g.FALSE, g.FALSE, 0)
		#hbox_tick.pack_start(vbox_tick, g.FALSE, g.FALSE, 0)

		frame_tick = g.Frame()
		frame_tick.set_label_widget(hbox_tick_frame)
		frame_tick.set_shadow_type(g.SHADOW_OUT)
		frame_tick.set_border_width(3)
		frame_tick.add(vbox_tick)
		#hbox_main.pack_start(frame_icon, g.FALSE, g.FALSE, 0)
		self.pack_start(frame_tick, g.FALSE, g.FALSE, 0)
		
		######### new horizontal Box
		hbox_main = g.HBox()
		
		vbox_icon_all = g.VBox(g.FALSE, 0)
		vbox_icon_all.set_border_width(3)
		######### icon html-adress
		hbox_icon = g.HBox()
		label3 = g.Label("http-adress")
		self.button3 = tool.EventImage(g.STOCK_CONVERT, self.fetch_icon, "fetch icon to local adress")
		hbox_icon.pack_start(label3, g.FALSE, g.FALSE, 3)
		hbox_icon.pack_end(self.button3, g.FALSE, g.FALSE, 3)
		vbox_icon_all.pack_start(hbox_icon, g.FALSE, g.FALSE, 0)
		self.e_icon = g.Entry()
		vbox_icon_all.pack_start(self.e_icon, g.FALSE, g.FALSE, 0)
		######### Spacer
		space_label= g.Label()
		vbox_icon_all.pack_start(space_label, g.FALSE, g.FALSE, 0)
		######### local icon
		hbox_iconcache = g.HBox()
		label4 = g.Label("local adress")
		self.button1 = tool.EventImage(g.STOCK_OPEN, self.open_cache_file, "choose file")
		hbox_iconcache.pack_start(label4, g.FALSE, g.FALSE, 0)
		hbox_iconcache.pack_end(self.button1, g.FALSE, g.FALSE, 0)
		vbox_icon_all.pack_start(hbox_iconcache, g.FALSE, g.FALSE, 0)
		self.e_iconcache = g.Entry()
		vbox_icon_all.pack_start(self.e_iconcache, g.FALSE, g.FALSE, 0)
		self.label5 = g.Label("[ icon in cachdir - see path conf ]")
		vbox_icon_all.pack_start(self.label5, g.FALSE, g.FALSE, 0)
		
		frame_icon = g.Frame("Icon Configuration")
		frame_icon.set_shadow_type(g.SHADOW_ETCHED_OUT)
		frame_icon.set_border_width(3)
		frame_icon.add(vbox_icon_all)
		hbox_main.pack_start(frame_icon, g.FALSE, g.FALSE, 0)
		
		######### right tab
		vbox_right_all = g.VBox()
		
		######### Number of News


		hbox_news_num = g.HBox(g.FALSE, 3)
		hbox_news_num.set_border_width(3)
		news_label = g.Label("max. Number\nof News to show")
		#label1.set_line_wrap(True)
		self.s_shownews = g.SpinButton(g.Adjustment(5, 1, 300, 1, 10, 10))
		hbox_news_num.pack_start(news_label, g.FALSE, g.FALSE, 0)
		hbox_news_num.pack_end(self.s_shownews, g.FALSE, g.FALSE, 0)
		frame_news = g.Frame("Ticker Configuration")
		frame_news.set_shadow_type(g.SHADOW_ETCHED_OUT)
		frame_news.set_border_width(3)
		frame_news.add(hbox_news_num)
		vbox_right_all.pack_start(frame_news, g.FALSE, g.FALSE, 0)
		
		######### date-infos
		
		hbox_date = g.HBox(g.FALSE, 3)
		hbox_date.set_border_width(3)
		date_label = g.Label("max news-age\nin minutes\n(0 to ignore)")
		self.s_news_age_by_date = g.SpinButton(g.Adjustment(5, 0, 10000, 1, 10, 10))
		hbox_date.pack_start(date_label, g.FALSE, g.FALSE, 0)
		hbox_date.pack_end(self.s_news_age_by_date, g.FALSE, g.FALSE, 0)
		
		self.frame_date = g.Frame("[ticker provides date info]")
		self.frame_date.get_label_widget().modify_fg(g.STATE_NORMAL, g.gdk.color_parse('#008000'))
		self.frame_date.set_shadow_type(g.SHADOW_ETCHED_OUT)
		self.frame_date.set_border_width(3)
		self.frame_date.add(hbox_date)
		vbox_right_all.pack_start(self.frame_date, g.FALSE, g.FALSE, 0)
		
		hbox_main.pack_start(vbox_right_all, g.FALSE, g.FALSE, 0)
		self.pack_start(hbox_main, g.FALSE, g.FALSE, 0)
		self.show_all()
		
		########
		#vsep = g.VSeparator()
		#vsep.show()
		#vsep.set_size_request(-1,95)
		#self.put (vsep, 180, 43)
		#self.add(hsep)
		self.active = 0
		self.ticker = ""
		self.icon = ""
		self.def_icon = "" # default icon position
		self.iconcache = ""
		self.def_iconcache = "" # default icon position in cache
		self.news_age_by_date = 0
		self.provides_date_info = None
		self.shownews = 5
		self.sig_ticker = None
		self.sig_icon = None
		self.sig_iconcache = None
		self.sig_news_age_by_date = None
		self.sig_shownews = None
		self.sig_active = None
		self.block_sig_ticker = 0
		self.block_sig_icon = 0
		self.WaitContainer_ticker = tool.WaitContainer(0.5, self.check_ticker_)
		self.WaitContainer_icon = tool.WaitContainer(0.5, self.check_icon_)
		self.WaitContainer_iconcache = tool.WaitContainer(0, self.check_iconcache_)
		self.WaitContainer_shownews = tool.WaitContainer(0.5, self.check_shownews_)
		self.WaitContainer_news_age_by_date = tool.WaitContainer(0.5, self.check_news_age_by_date_)
		#######
	def check_date_age(self):
		if self.provides_date_info: self.frame_date.show()
		else: self.frame_date.hide()
	def open_cache_file(self, widget, event):
		def set_cache_file(widget):
			sel.hide()
			self.set_iconcache(sel.get_filename())
		def exit(widget):
			sel.hide()
		if event.button == 1:
			sel = g.FileSelection()
			if self.iconcache <> "":
				sel.set_filename(self.long_dir(self.iconcache))
			else: sel.set_filename(self.long_dir(self.def_iconcache))
			sel.connect("destroy", exit)
			sel.ok_button.connect("clicked", set_cache_file)
			sel.cancel_button.connect("clicked", exit)
			sel.show()
	def activate_Signals(self):
		if self.__Options.v: print "activate Page-Item SIGNALs"
		if not(self.sig_ticker): self.sig_ticker = self.e_ticker.connect('changed',self.check_ticker)
		if not(self.sig_icon): self.sig_icon = self.e_icon.connect('changed',self.check_icon)
		if not(self.sig_iconcache): self.sig_iconcache = self.e_iconcache.connect('changed',self.check_iconcache)
		if not(self.sig_shownews): self.sig_shownews = self.s_shownews.connect('value-changed',self.check_shownews)
		if not(self.sig_news_age_by_date): self.sig_news_age_by_date = self.s_news_age_by_date.connect('value-changed',self.check_news_age_by_date)
	def deactivate_Signals(self):
		if self.__Options.v: print "deactivate Page-Item SIGNALs"
		if self.sig_ticker:
			self.e_ticker.disconnect(self.sig_ticker); self.sig_ticker = None
		if self.sig_icon:
			self.e_icon.disconnect(self.sig_icon); self.sig_icon = None
		if self.sig_iconcache:
			self.e_iconcache.disconnect(self.sig_iconcache); self.sig_iconcache = None
		if self.sig_shownews:
			self.s_shownews.disconnect(self.sig_shownews); self.sig_shownews = None
		if self.sig_news_age_by_date:
			self.s_news_age_by_date.disconnect(self.sig_news_age_by_date); self.sig_news_age_by_date = None
	def fetch_icon(self, widget, event):
		url = self.icon
		if url == "": url = self.def_icon
		#print url
		file = self.iconcache
		if file == "": file = self.def_iconcache
		self.icon_image_tab.get_from_uri_(self.http(url),file, self.ticker)
	def check_shownews(self,value): self.WaitContainer_shownews.set_value(self.s_shownews.get_value())
	def check_shownews_(self,value):
		self.shownews = int(self.s_shownews.get_value())
		if self.__Options.v: print "changed shownews"
		self.emit('changed_Page',self)
	def check_news_age_by_date(self,value): self.WaitContainer_news_age_by_date.set_value(self.s_news_age_by_date.get_value())
	def check_news_age_by_date_(self,value):
		self.news_age_by_date = int(self.s_news_age_by_date.get_value())
		if self.__Options.v: print "changed news_age_by_date"
		self.emit('changed_Page',self)
	def switch_active(self, widget, event):
		if self.__Options.v: print "switch active"
		if self.active == 1: self.active = 0
		else: self.active = 1
		self.check_active()		
	def check_active(self):
		if self.active == 1:
			self.button2.set_from_stock(g.STOCK_YES)
			self.button2.set_small()
			self.button2.set_tip("click to deactivate")
			self.tick_frame_label.set_text(" News Source (click button to deactivate)")
		else:
			self.button2.set_from_stock(g.STOCK_NO)
			self.button2.set_small()
			self.button2.set_tip("click to activate")
			self.tick_frame_label.set_text(" News Source (click button to activate)")
		self.icon_image_tab.set_active(self.active)
		if self.__Options.v: print "changed active"
		self.emit('changed_Page',self)
	def short_dir(self,value):
		if value.find(self.__Options.icon_cache_dir.value) == 0:
			return "[...]"+value[len(self.__Options.icon_cache_dir.value):]
		return value
	def long_dir(self,value):
		if value.find("[...]") == 0:
			return self.__Options.icon_cache_dir.value + value[5:]
		return value	
	def set_ticker(self, wert):
		self.e_ticker.set_text(wert)
		self.check_ticker(None)
	def check_ticker(self,value): self.WaitContainer_ticker.set_value(self.e_ticker.get_text())
	def check_ticker_(self,value):
		self.deactivate_Signals()
		self.block_sig_ticker = 1
		self.ticker = self.e_ticker.get_text()
		if self.ticker.find("http://") == 0:
			pos = self.ticker[8:].find("/")
			if pos <> -1: pos = pos + 8
		else:	pos = self.ticker.find("/")
		if pos <> -1: self.def_icon =  self.ticker[:pos] + "/favicon.ico"
		else:	self.def_icon =  self.ticker + "/favicon.ico"
		if self.icon == "":
			self.e_icon.set_text(self.def_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('grey'))
		self.check_icon(None)
		if self.__Options.v: print "changed ticker"
		self.block_sig_ticker = 0
		self.activate_Signals()
		self.emit('changed_Page',self)
	def set_icon(self, wert):
		self.e_icon.set_text(wert)
		self.check_icon(None)
	def check_icon(self,value): self.WaitContainer_icon.set_value(self.e_icon.get_text())
	def check_icon_(self,value):
		if not(self.block_sig_ticker): self.deactivate_Signals()
		self.block_sig_icon = 1
		tmp_icon = self.e_icon.get_text()
		if tmp_icon <> self.def_icon:
			self.icon = tmp_icon
			self.def_iconcache = tool.tmp_name(self.__Options.icon_cache_dir.value, tmp_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('black'))
		else: 	
			self.icon = ""
			self.def_iconcache = tool.tmp_name(self.__Options.icon_cache_dir.value, self.def_icon)
			self.e_icon.modify_text(g.STATE_NORMAL,self.e_icon.get_colormap().alloc_color('grey'))
		if self.iconcache == "":
			self.e_iconcache.set_text(self.short_dir(self.def_iconcache))
			self.label5.show()
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('grey'))
		self.check_iconcache(None)
		if self.__Options.v: print "changed icon"
		if not(self.block_sig_ticker):
			self.block_sig_icon = 0
			self.activate_Signals()
			self.emit('changed_Page',self)
		else: self.block_sig_icon = 0
	def set_iconcache(self, wert):
		self.e_iconcache.set_text(wert)
		self.check_iconcache(None)
	def check_iconcache(self,value): self.WaitContainer_iconcache.set_value(self.e_iconcache.get_text())
	def check_iconcache_(self,value):
		#print "check_iconcache_ fired"
		if not(self.block_sig_ticker) and not(self.block_sig_icon): self.deactivate_Signals()
		tmp_iconcache = self.short_dir(self.e_iconcache.get_text())
		self.e_iconcache.set_text(tmp_iconcache)
		if tmp_iconcache.find("[...]") == 0: self.label5.show()
		else: self.label5.hide()
		if tmp_iconcache <> self.short_dir(self.def_iconcache):
			self.iconcache = tmp_iconcache
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('black'))
			self.icon_image_tab.get_from_file_(self.long_dir(self.iconcache), self.ticker)
		else:
			self.iconcache = ""
			self.e_iconcache.set_text(tmp_iconcache)
			self.e_iconcache.modify_text(g.STATE_NORMAL,self.e_iconcache.get_colormap().alloc_color('grey'))
			self.icon_image_tab.get_from_file_(self.def_iconcache, self.ticker)
		if self.__Options.v: print "changed iconcache"
		if not(self.block_sig_ticker) and not(self.block_sig_icon):
			self.activate_Signals()
			self.emit('changed_Page',self)
	def http(self, value):
		if value.find("://") == -1: return "http://" + value
		return value		
	def set(self,value):
		if self.__Options.v: print "PAGE set"
		self.active = tool.getintdata(value, "active")
		self.check_active()
		tmp_ticker = tool.getdata(value, "ticker")
		self.set_ticker(tmp_ticker)
		tmp_icon = tool.getdata(value, "icon")
		if tmp_icon <> "": self.set_icon(tmp_icon)
		tmp_iconcache = tool.getdata(value, "iconcache")
		if tmp_iconcache <> "": self.set_iconcache(tmp_iconcache)
		self.shownews = tool.getintdata(value, "shownews")
		self.s_shownews.set_value(self.shownews)
		self.news_age_by_date = tool.getintdata(value, "news_age_by_date")
		self.s_news_age_by_date.set_value(self.news_age_by_date)
		self.provides_date_info = tool.getintdata(value, "provides_date_info")
		self.check_date_age()
		self.WaitContainer_iconcache.set_time(0.5)
	def _to_xml(self, parent):
		if self.ticker == '': return
		doc = parent.ownerDocument
		root = doc.createElement('source')
		parent.appendChild(root)
		doc = root.ownerDocument
		node = doc.createElement('active')
		node.appendChild(doc.createTextNode(str(self.active)))
		root.appendChild(node)
		node = doc.createElement('ticker')
		node.appendChild(doc.createTextNode(self.ticker))
		root.appendChild(node)
		node = doc.createElement('icon')
		node.appendChild(doc.createTextNode(self.icon))
		root.appendChild(node)
		node = doc.createElement('iconcache')
		if self.iconcache <> "":
			node.appendChild(doc.createTextNode(self.long_dir(self.iconcache)))
		else:
			node.appendChild(doc.createTextNode(""))
		root.appendChild(node)
		node = doc.createElement('shownews')
		node.appendChild(doc.createTextNode(str(self.shownews)))
		root.appendChild(node)
		node = doc.createElement('news_age_by_date')
		node.appendChild(doc.createTextNode(str(self.news_age_by_date)))
		root.appendChild(node)
		node = doc.createElement('provides_date_info')
		node.appendChild(doc.createTextNode(str(self.provides_date_info)))
		root.appendChild(node)

	
class Help_Container(g.Frame):
	def __init__(self):
		g.Frame.__init__(self)
		swin=g.ScrolledWindow()
		swin.set_policy(g.POLICY_AUTOMATIC,g.POLICY_AUTOMATIC)
		swin.show()
		self.add(swin)
		textbuf = g.TextBuffer(None)
 		file = open( rox.app_dir + "/Help/" + "Help.txt","r")
		text = unicode(file.read(), 'iso-8859-1')
		file.close()
		ebox = g.EventBox()
		ebox.show()
		ebox.modify_bg(g.STATE_NORMAL,ebox.get_colormap().alloc_color('white'))
		vbox = g.VBox()
		vbox.show()
		hbox = g.HBox()
		hbox.show()
		label = g.Label()
		label.set_markup(text)
		label.set_line_wrap(True)
		label.set_size_request(280,-1)
		label.show()
		hbox.pack_start(label,g.FALSE,g.FALSE,15)
		#vbox.pack_start(label,g.FALSE,g.FALSE,10)
		vbox.pack_start(hbox,g.FALSE,g.FALSE,0)
		ebox.add(vbox)
		swin.add_with_viewport(ebox)
		self.set_size_request(345,300)
		self.show()





class TickPrefs_Container(g.VBox):
	def __init__(self, Options):
		self.__Options = Options
		self.pageCount = 0
		g.VBox.__init__(self, g.FALSE, 3)
		
		hbox = g.HBox(g.FALSE, 0)
		self.notebook = g.Notebook()
		self.notebook.set_scrollable(True)
		self.pack_start(self.notebook, g.FALSE, g.FALSE, 0)
		#button1 = rox.ButtonMixed(g.STOCK_REFRESH, "refresh Sources")
		#button1.connect('clicked', self.refresh)
		
		#hbox.pack_end(button1, g.FALSE, g.FALSE, 0)
		
		
		button2 = rox.ButtonMixed(g.STOCK_NEW, "New Source")
		button2.connect('clicked', self.add_Page)
		button4 = rox.ButtonMixed(g.STOCK_DELETE, "Kill Source")
		button4.connect('clicked', self.kill_Page)
		
		
		hbox.pack_start(button2, g.FALSE, g.FALSE, 0)
		hbox.pack_start(button4, g.FALSE, g.FALSE, 3)
		self.pack_start(hbox, g.FALSE, g.FALSE, 3)
		self.show_all()
		#self.no_sig.hide()
		#self.connect("destroy", self.ende)
	#def ende(self, dummy):
		#print "destroy PrefContainer"
	def kill_Page(self, value):
		killpage = self.notebook.get_nth_page(self.notebook.get_current_page())
		change = killpage.ticker <> "" or \
			killpage.icon <> ""
		self.notebook.remove_page(self.notebook.get_current_page())
		#self.pages = []
		self.pageCount -= 1
		if change: self.emit('changed_Conti',self)
	def hello_(self, value, value2):
		if self.__Options.v: print "SIGNAL: changed Page " + str(self.notebook.get_current_page())
		self.emit('changed_Conti',self)
	def add_Page(self,value):
		newpage = ConfigPage(self.__Options)
		newpage.show()
		self.notebook.append_page(newpage, newpage.icon_image_tab)
		self.pageCount += 1
		newpage.activate_Signals()
		newpage.connect('changed_Page', self.hello_)
		self.notebook.set_current_page(self.notebook.page_num(newpage))		
	def add_Page_Set(self,value):
		newpage = ConfigPage(self.__Options)
		newpage.show()
		#print "newpage created"
		self.notebook.append_page(newpage, newpage.icon_image_tab)
		self.pageCount += 1
		#print "newpage added"
		newpage.set(value)
		newpage.activate_Signals()
		newpage.connect('changed_Page', self.hello_)
		#print "newpage values set"
	def get_xml(self):
		from xml.dom.minidom import Document
		doc = Document()
		root = doc.createElement('Options')
		doc.appendChild(root)
		for i in range(0, self.pageCount):
			self.notebook.get_nth_page(i)._to_xml(root)
		return doc		
	def get_value(self):
		doc = self.get_xml()
		return doc.toxml()
	def load_config(self, config):
		
		currentPage = self.notebook.get_current_page()
		for i in range(0,self.pageCount):
			self.notebook.remove_page(0)
		#print "pages removed"
		self.pageCount = 0
		from xml.dom import Node, minidom
		doc = minidom.parseString(tool.unxml(config))
		for i in doc.getElementsByTagName("source"):
			#print "add page"
			self.add_Page_Set(i)
		if currentPage <> -1: self.notebook.set_current_page(currentPage)

gobject.signal_new("changed_Conti", TickPrefs_Container, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))
		
gobject.signal_new("changed_Page", ConfigPage, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))

def auweia(dummy):
	print "auwiea"
	
def kill_tp(widget):
	yield tasks.TimeoutBlocker(0.3)
	print "kill"
	widget.destroy()
	print "done"
	yield None

class TickPrefs(rox.Window): ### only for testing purposes
	def __init__(self):
		rox.Window.__init__(self)
		self.pages = []
		table = g.Table()
		table.show()
		self.add(table)
		fixed = TickPrefs_Container()
		fixed.show()
		table.add(fixed)
		#self.set_events(g.gdk.DESTROY)
		self.connect("destroy", self.ende)
		#self.connect("delete-event", auweia)
		#auweia()
	def ende(self, dummy):
		print "ende"
	def __del__(self):
		print "Container closed"

#tp = TickPrefs()
#tp.show()
#tasks.Task(kill_tp(tp))
#rox.mainloop()
